# SPDX-License-Identifier: AGPL-3.0-or-later
# Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
# Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
#
# DAMASK is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
import shutil

import pytest
import numpy as np

import damask

@pytest.fixture
def res_path(res_path_base):
    """Directory containing testing resources."""
    return res_path_base/'YAML_parse'


@pytest.mark.parametrize('fname',np.arange(7))
def test_YAML_parse(res_path,tmp_path,copy_files,fname):

    load = 'none'
    grid = 'simple'
    material = 'material'

    copy_files(res_path,tmp_path,[f'{load}.yaml',f'{grid}.vti'])
    shutil.copy(res_path/f'{fname}.yaml',tmp_path/f'{material}.yaml')

    stdout,stderr = damask.util.run(f'damask_grid -l {load}.yaml -g {grid}.vti -m {material}.yaml',wd=tmp_path)


def test_CRLF(res_path,tmp_path,copy_files):

    load = 'none'
    grid = 'simple'
    material = 'material'

    copy_files(res_path,tmp_path,[f'{load}.yaml',f'{grid}.vti'])
    shutil.copy(res_path/'CRLF.yaml',tmp_path/f'{material}.yaml')

    stdout,stderr = damask.util.run(f'damask_grid -l {load}.yaml -g {grid}.vti -m {material}.yaml',wd=tmp_path)
